﻿using Infragistics.Win.AppStyling;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Superviseur
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            
            //Properties.Settings.Default.DefaultStyle = "Nautilus";
            //Properties.Settings.Default.Save();

            LoadFrench();

            string style = Path.Combine(Application.StartupPath, "Styles");
            style += @"\" + Properties.Settings.Default.DefaultStyle + ".isl";
            StyleManager.Load(style);
            StyleManager.DefaultStyleSetName = Properties.Settings.Default.DefaultStyle;
            Application.SetCompatibleTextRenderingDefault(false);

            Application.Run(new SupervisionFrm());
        }

        public static void SavePreset(string name, UltraGrid grid)
        {
            Directory.CreateDirectory(Application.StartupPath + @"\preset\");
            string path = Application.StartupPath + @"\preset\" + name;
            grid.DisplayLayout.SaveAsXml(path);
        }

        public static void LoadPreset(string name, UltraGrid grid)
        {
            string path = Application.StartupPath + @"\preset\" + name;
            if (File.Exists(path))
            {
                grid.DisplayLayout.LoadFromXml(path);
            }
        }

        public static bool isAdmin = false;

        private static void LoadFrench()
        {
            Infragistics.Shared.ResourceCustomizer rc = null;

            rc = Infragistics.Win.UltraWinGrid.Resources.Customizer;
            rc.SetCustomizedString("RowFilterDropDown_Operator_Contains", "Contient");
            rc.SetCustomizedString("RowFilterDropDown_Operator_DoesNotContain", "Ne contient pas");
            rc.SetCustomizedString("RowFilterDropDown_Operator_DoesNotEndWith", "Ne se termine pas par");
            rc.SetCustomizedString("RowFilterDropDown_Operator_DoesNotMatch", "Ne convient pas");
            rc.SetCustomizedString("RowFilterDropDown_Operator_DoesNotStartWith", "Ne commence pas par");
            rc.SetCustomizedString("RowFilterDropDown_Operator_EndsWith", "Se termine par");
            rc.SetCustomizedString("RowFilterDropDown_Operator_Like", "comme");
            rc.SetCustomizedString("RowFilterDropDown_Operator_Match", "correspond à");
            rc.SetCustomizedString("RowFilterDropDown_Operator_NotLike", "Différent de");
            rc.SetCustomizedString("RowFilterDropDown_Operator_StartsWith", "Commence par");
            rc.SetCustomizedString("RowFilterDropDownAllItem", "Tous");
            rc.SetCustomizedString("RowFilterDropDownBlanksItem", "(vide)");
            rc.SetCustomizedString("RowFilterDropDownCustomItem", "(custom)");
            rc.SetCustomizedString("RowFilterDropDownEquals", "Egal");
            rc.SetCustomizedString("RowFilterDropDownErrorsItem", "(Erreur)");
            rc.SetCustomizedString("RowFilterDropDownGreaterThan", "Supérieur à");
            rc.SetCustomizedString("RowFilterDropDownGreaterThanOrEqualTo", "Supérieur ou égale");
            rc.SetCustomizedString("RowFilterDropDownLessThan", "Inférieur à");
            rc.SetCustomizedString("RowFilterDropDownLessThanOrEqualTo", "Inférieur ou égale");
            rc.SetCustomizedString("RowFilterDropDownLike", "Comme");
            rc.SetCustomizedString("RowFilterDropDownMatch", "Correspond à l'expression régulière");
            rc.SetCustomizedString("RowFilterDropDownNonBlanksItem", "(Non vide)");
            rc.SetCustomizedString("RowFilterDropDownNonErrorsItem", "(sans erreur)");
            rc.SetCustomizedString("RowFilterDropDownNotEquals", "Pas égal à");
            rc.SetCustomizedString("RowFilterLogicalOperator_And", "ET");
            rc.SetCustomizedString("RowFilterLogicalOperator_Or", "OU");
            rc.SetCustomizedString("RowFilterPatternCaption", "Expression de recherche invalide");
            rc.SetCustomizedString("RowFilterPatternError", "Erreur d'analyse de l'expression {0}. Entrer une expression de recherche valide");
            rc.SetCustomizedString("RowFilterLogicalOperator_And", "ET");
        }
    }
}
