﻿using Infragistics.Win;
using Infragistics.Win.AppStyling;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Superviseur
{
    public partial class Stylechooser : Form
    {        
        public Stylechooser()
        {
            InitializeComponent();
        }

        private string DefaultStyle = string.Empty;
        private void Stylechooser_Load(object sender, EventArgs e)
        {
            DefaultStyle = StyleManager.DefaultStyleSetName;
            FillStyleList();            
        }

        private void FillStyleList()
        {
            Styles.Items.Clear();
            DirectoryInfo stylesFolder = new DirectoryInfo(Path.Combine(Application.StartupPath, "Styles"));
            FileInfo[] styleFiles = stylesFolder.GetFiles("*.isl");

            foreach (FileInfo styleFile in styleFiles)
            {
                string name = styleFile.Name.Substring(0, styleFile.Name.Length - 4);
                if (name != string.Empty)
                {
                    ValueListItem item = Styles.Items.Add(styleFile, name);
                    if (name == DefaultStyle)
                    {
                        Styles.SelectedItem = item;
                    }
                }
            }
        }

        private void cmbStyles_ValueChanged(object sender, EventArgs e)
        {
            if (Styles.Value != null)
            {
                FileInfo styleFile = Styles.Value as FileInfo;
                if (styleFile != null)
                {
                    StyleManager.Load(styleFile.FullName);
                }
            }
        }

        private void ApplyBtn_Click(object sender, EventArgs e)
        {
            if (Styles.Value != null)
            {
                FileInfo styleFile = Styles.Value as FileInfo;
                if (styleFile != null)
                {
                    StyleManager.Load(styleFile.FullName);
                    StyleManager.DefaultStyleSetName = Styles.Text;
                    Properties.Settings.Default.DefaultStyle = Styles.Text;
                    Properties.Settings.Default.Save(); 
                }
            }
        }

        private void CancelBtn_Click(object sender, EventArgs e)
        {
            string style = Path.Combine(Application.StartupPath, "Styles");
            style += @"\" + DefaultStyle + ".isl";
            StyleManager.Load(style);
            StyleManager.DefaultStyleSetName = DefaultStyle;
            
            
        }        
    }
}
