﻿using Superviseur.Properties;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Superviseur
{
    public partial class SupervisionFrm : Form
    {

        #region Private members

        private Visualisation_Suivi historique = null;

        #endregion

        public SupervisionFrm()
        {
            InitializeComponent();
        }

        #region Menu action

        private void suiviDesActionsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DisplayHistorique();
        }


        private void styleApplicationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DisplayStyle();
        }

        #endregion


        #region Private method tools

        private void HideAllButThis(Control toKeep)
        {
            foreach (Control c in ActionPanel.Controls)
            {
                if (c != toKeep)
                {
                    c.Visible = false;
                }
                else
                {
                    c.Visible = true;
                }
            }
        }

        #endregion


        #region Manager User Control Display

        
        private void DisplayStyle()
        {
            Stylechooser style = new Stylechooser();
            style.ShowDialog();
        }

        private void DisplayHistorique()
        {
            bool needUpdate = true;
            if (historique == null)
            {
                historique = new Visualisation_Suivi();
                this.ActionPanel.Controls.Add(historique);
                historique.Dock = DockStyle.Fill;
                needUpdate = false;
            }

            HideAllButThis(historique);
            if (needUpdate)
            {
                historique.UpdateGrid();
            }
        }


        #endregion

        private void SupervisionFrm_FormClosing(object sender, FormClosingEventArgs e)
        {
            SavePreset();
        }

        private void SavePreset()
        {
            if (historique != null)
            {
                historique.SavePreset();
            }
        }

        private void quitterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SavePreset();
            Application.Exit();
        }

        private void SupervisionFrm_Load(object sender, EventArgs e)
        {            
        }
        
        private void imprimerToolStripMenuItem_Click(object sender, EventArgs e)
        {            
            if ((historique != null) && (historique.Visible))
            {
                historique.Print();
            }
        }
                
        private void chargerUneArchiveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LoadArchive();    
        }

        private void LoadArchive()
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Database (*.s3db)|*.s3db";
            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                Properties.Settings.Default["DefaultConnectionString"] = "data source=" + ofd.FileName;

                RefreshConnectionString();
            }
        }

        private void RefreshConnectionString()
        {
            // et on rafraichit toutes les fenetres...
            if (historique != null)
            {
                historique.LoadData();
            }
        }
    }
}
