﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Documents.Excel;
using System.Drawing.Printing;
using Superviseur.Properties;
using System.Diagnostics;

namespace Superviseur
{
    public partial class Visualisation_Suivi : UserControl
    {
        private List<MyItem> items = null;

        public Visualisation_Suivi()
        {
            InitializeComponent();
            items = new List<MyItem>();
            for (int i = 0; i < 10; i++)
            {
                MyItem my = new MyItem((i + 1), DateTime.Now, "ERREUR");
                items.Add(my);
            }
            myItemBindingSource.DataSource = items;
        }

        private void UpdateBtn_Click(object sender, EventArgs e)
        {
            UpdateDateFilter();
            UpdateGrid();
        }

        public void UpdateGrid()
        {
            Cursor = Cursors.WaitCursor;
            Application.DoEvents();                              
            EtatGrid.UpdateData();
            Cursor = Cursors.Arrow;
        }

        bool canUpdate= false;

        private void Visualisation_Suivi_Load(object sender, EventArgs e)
        {            
            DateDebut.DateTime = DateTime.Now;
            DateFin.DateTime = DateTime.Now;
            canUpdate = true;
            UpdateDateFilter();
            LoadData();
            EtatGrid.DisplayLayout.Bands[0].PerformAutoResizeColumns(false, Infragistics.Win.UltraWinGrid.PerformAutoSizeType.VisibleRows);
        }

        private void UpdateDateFilter()
        {            
            //suiviBindingSource.Filter = "DateDepose >='" + DateDebut.DateTime.ToString("dd/MM/yyyy") + "' And DateDepose <='" + DateFin.DateTime.ToString("dd/MM/yyyy") + "'";
        }

        public void LoadData()
        {
            Cursor = Cursors.WaitCursor;
            Application.DoEvents();
            //suiviTableAdapter.Connection.ConnectionString = Settings.Default.DefaultConnectionString;
            //suiviTableAdapter.Adapter.SelectCommand = new System.Data.SQLite.SQLiteCommand("SELECT [TerminalID], [MatPrise], [ArmoireID], [DatePrise], [HeurePrise], [MatDepose], [DateDepose], [HeureDepose], [Process] FROM [Suivi]");
            //suiviTableAdapter.Fill(this.defaultDataSet.Suivi);
            Cursor = Cursors.Arrow;
        }

        private void EtatGrid_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            //Program.LoadPreset("Historique.xml", EtatGrid);
            //e.Layout.Bands[0].Columns["HeurePrise"].Format = "HH:mm:ss";
            //e.Layout.Bands[0].Columns["DatePrise"].Format = "dd/MM/yyyy";
            //e.Layout.Bands[0].Columns["HeureDepose"].Format = "HH:mm:ss";
            //e.Layout.Bands[0].Columns["DateDepose"].Format = "dd/MM/yyyy";
        }
        
        public void SavePreset()
        {
            Program.SavePreset("Historique.xml", EtatGrid);            
        }

        private void EtatGrid_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if(e.Row.Cells["Process"].Value.ToString() != "OK")
            {
                e.Row.Appearance.AlphaLevel = 200;
                //e.Row.Appearance.BackColorAlpha = Infragistics.Win.Alpha.UseAlphaLevel;
                e.Row.Appearance.BackColorAlpha = Infragistics.Win.Alpha.Opaque;
                //e.Row.Appearance.BackColorAlpha = Infragistics.Win.Alpha.Default;
                e.Row.Appearance.BackColor = Color.Red;
            }
        }

        public void Export()
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Title = "Export Excel";
            sfd.Filter = "Excel 2010(*.xlsx)|*.xlsx|Excel 2007 (*.xls)|*.xls";
            
            if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                try
                {
                    EtatExporter.Export(EtatGrid, sfd.FileName);    
                }
                catch (Exception)
                {
                    MessageBox.Show("Le fichier est en cours d'utilisation.\n\nL'export a échoué");
                }                
            }                        
        }

        private void EtatExporter_HeaderRowExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.HeaderRowExportingEventArgs e)
        {            
        }

        private void EtatExporter_EndExport(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.EndExportEventArgs e)
        {
            e.CurrentWorksheet.Name = "Historique";            
        }

        public void Print()
        {
            PrintDocument pd = new PrintDocument();            
            pd.DefaultPageSettings.Landscape = true;
            pd.DocumentName = "Historique";
            pd.DefaultPageSettings.PrinterResolution.Kind = PrinterResolutionKind.High;
            EtatGrid.PrintPreview(EtatGrid.DisplayLayout,pd);
            //EtatGrid.Print(EtatGrid.DisplayLayout, pd);
        }

        private void DateDebut_ValueChanged(object sender, EventArgs e)
        {
            //if (canUpdate)
            //{
            //    UpdateDateFilter();
            //    UpdateGrid();
            //}
        }

        private void DateFin_ValueChanged(object sender, EventArgs e)
        {
            //if (canUpdate)
            //{
            //    UpdateDateFilter();
            //    UpdateGrid();
            //}
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {            
            EtatGrid.DisplayLayout.Bands[0].ClearGroupByColumns();            
        }

        private void EtatExporter_HeaderCellExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.HeaderCellExportingEventArgs e)
        {
            e.GridHeader.Appearance.ForeColor = Color.Black;
        }

        private void myItemBindingSource_CurrentChanged(object sender, EventArgs e)
        {

        }
    }

    public class MyItem
    {
        private int id;

        public int Id
        {
            get { return id; }
            set { id = value; }
        }
        private DateTime dateDepot = DateTime.Now;

        public DateTime DateDepot
        {
            get { return dateDepot; }
            set { dateDepot = value; }
        }
        private string process = "ERREUR";
        private DateTime dateTime;

        public MyItem(int p1, DateTime dateTime, string p2)
        {
            // TODO: Complete member initialization
            this.id = p1;
            this.dateTime = dateTime;
            this.process = p2;
        }

        public string Process
        {
            get { return process; }
            set { process = value; }
        }
    }
}
